# Uses of Interface
org.apache.lucene.util.BytesRefIterator

Packages that use BytesRefIterator
Package
Description
org.apache.lucene.index
Code to maintain and access indices.
org.apache.lucene.search
Code to search indices.
org.apache.lucene.util
Some utility classes.
org.apache.lucene.util.automaton
Finite-state automaton for regular expressions.

## Uses of BytesRefIterator in org.apache.lucene.index

Classes in org.apache.lucene.index that implement BytesRefIterator
Modifier and Type
Class
Description
`class`
`AutomatonTermsEnum`
A FilteredTermsEnum that enumerates terms based upon what is accepted by a DFA.
`class`
`BaseTermsEnum`
A base TermsEnum that adds default implementations for `BaseTermsEnum.attributes()` `BaseTermsEnum.termState()` `BaseTermsEnum.seekExact(BytesRef)` `BaseTermsEnum.seekExact(BytesRef, TermState)` In some cases, the default implementation may be slow and consume huge memory, so subclass SHOULD have its own implementation if possible.
`static class`
`ExitableDirectoryReader.ExitableTermsEnum`
Wrapper class for TermsEnum that is used by ExitableTerms for implementing an exitable enumeration of terms.
`class`
`FilteredTermsEnum`
Abstract class for enumerating a subset of all terms.
`static class`
`FilterLeafReader.FilterTermsEnum`
Base class for filtering `TermsEnum` implementations.
`final class`
`MultiTermsEnum`
Exposes `TermsEnum` API, merged from `TermsEnum` API of sub-segments.
`static class`
`PrefixCodedTerms.TermIterator`
An iterator over the list of terms stored in a `PrefixCodedTerms`.
`final class`
`SingleTermsEnum`
Subclass of FilteredTermsEnum for enumerating a single term.
`class`
`TermsEnum`
Iterator to seek (`TermsEnum.seekCeil(BytesRef)`, `TermsEnum.seekExact(BytesRef)`) or step through (`next()` terms to obtain frequency information (`TermsEnum.docFreq()`), `PostingsEnum` or `PostingsEnum` for the current term (`TermsEnum.postings(org.apache.lucene.index.PostingsEnum)`.

## Uses of BytesRefIterator in org.apache.lucene.search

Classes in org.apache.lucene.search that implement BytesRefIterator
Modifier and Type
Class
Description
`final class`
`FuzzyTermsEnum`
Subclass of TermsEnum for enumerating all terms that are similar to the specified filter term.
`static class`
`PointInSetQuery.Stream`
Iterator of encoded point values.
Methods in org.apache.lucene.search that return BytesRefIterator
Modifier and Type
Method
Description
`BytesRefIterator`
TermInSetQuery.`getBytesRefIterator()`
Get an iterator over the encoded terms for query inspection.
Methods in org.apache.lucene.search with parameters of type BytesRefIterator
Modifier and Type
Method
Description
`static MatchesIterator`
MatchesUtils.`disjunction(LeafReaderContext context, int doc, Query query, String field, BytesRefIterator terms)`
Create a MatchesIterator that is a disjunction over a list of terms extracted from a `BytesRefIterator`.

## Uses of BytesRefIterator in org.apache.lucene.util

Subinterfaces of BytesRefIterator in org.apache.lucene.util
Modifier and Type
Interface
Description
`static interface`
`BytesRefArray.IndexedBytesRefIterator`
An extension of `BytesRefIterator` that allows retrieving the index of the current element
Classes in org.apache.lucene.util that implement BytesRefIterator
Modifier and Type
Class
Description
`static class`
`OfflineSorter.ByteSequencesReader`
Utility class to read length-prefixed byte[] entries from an input.
Fields in org.apache.lucene.util declared as BytesRefIterator
Modifier and Type
Field
Description
`static final BytesRefIterator`
BytesRefIterator.`EMPTY`
Singleton BytesRefIterator that iterates over 0 BytesRefs.
Methods in org.apache.lucene.util that return BytesRefIterator
Modifier and Type
Method
Description
`BytesRefIterator`
BytesRefArray.`iterator()`
sugar for `BytesRefArray.iterator(Comparator)` with a `null` comparator
`BytesRefIterator`
BytesRefArray.`iterator(Comparator<BytesRef> comp)`
Returns a `BytesRefIterator` with point in time semantics.

## Uses of BytesRefIterator in org.apache.lucene.util.automaton

Methods in org.apache.lucene.util.automaton with parameters of type BytesRefIterator
Modifier and Type
Method
Description
`static Automaton`
Automata.`makeBinaryStringUnion(BytesRefIterator utf8Strings)`
Returns a new (deterministic and minimal) automaton that accepts the union of the given iterator of `BytesRef`s representing UTF-8 encoded strings.
`static Automaton`
Automata.`makeStringUnion(BytesRefIterator utf8Strings)`
Returns a new (deterministic and minimal) automaton that accepts the union of the given iterator of `BytesRef`s representing UTF-8 encoded strings.